#ifndef GRAPH_GML_H_
#define GRAPH_GML_H_ 
#include <stdio.h>
#include <string>
#include <vector>

#define MAX_POINTS_EDGES 20

using namespace std;

class graph_gml {

 public:

  int num_nodes;
  int num_edges;
  
  vector <int> node_id;
  vector <string> node_label;
  
  /*GRAPHICS - EACH NODE*/
  vector <double> node_x;
  vector <double> node_y;
  vector <double> node_w;
  vector <double> node_h;
  vector <string> node_fill;
  vector <string> node_line;
  vector <string> node_cla;
  vector <string> node_subcla;
  vector <int> node_nasc;
  vector <int> node_morte;
  /*string * pattern;
    int * stipple;*/
  vector <double> node_lineWidth;
  vector <string> node_type;
  vector <double> node_width;

  /*GRAPHICS - EACH EDGE*/
  vector <int> edge_source;
  vector <int> edge_target;
  /*string * edge_type;
    string * edge_arrow;*/
  vector <double> edge_lineWidth;
  vector <double *> edge_points_x;
  vector <double *> edge_points_y;
  vector <int> edge_num_points;
  vector <string> edge_fill;

  graph_gml ();
  
  graph_gml (string file_gml);

  ~graph_gml ();

  void read_gml (char * file_gml);
  
  void print_gml ();
  
  void clear_gml ();

  void print_graph_gml ();

  int find_node_id_gml (int label);

  int find_edge_id_gml (int label1, int label2);
  
  bool son (int v, int w);
  
};
#endif /*GRAPH_GML_H_*/
